#!/usr/bin/perl

# Start script for genome wide Allegro scan , chromosome by chromosome 
# (c) 2004 Franz Rueschendorf 

# usage: perl allegro_start.pl [weightsfile]

use Cwd;
use strict;
use File::Copy;

my $weights="equal";
if ($ARGV[0] =~ "^weights" ) { $weights=$ARGV[0];}

foreach my $chr ("11"){
foreach my $chr ("01","02","03","04","05","06","07","08","09","10","11","12","13","14","15","16","17","18","19","20","21","22",23,24) {

	if ( -d "c$chr") {
		if ( $weights ne "equal") { copy ("$weights","c${chr}/$weights");}

		chdir "c${chr}";
		print "Chromosome $chr\n";
		if (-f "allegro.log") {unlink "allegro.log";}
		if (-f "param_mpt.$chr") {unlink "param_mpt.$chr";}
#		unlink glob("*_mpt.$chr");
#		if ( ! -d "SWAPDIR") {mkdir ("SWAPDIR",0777);}
		
		open (OUT,">allegro.in") || die "could not open allegro.in :$!\n";
		print OUT "PREFILE pedin.$chr\n"; 
		print OUT "DATFILE datain.$chr\n";

################ Edit Allegro Options here #############
		if ($weights eq "equal"){
			print OUT "MODEL mpt par het param_mpt.$chr\n";
#			print OUT "MODEL mpt exp pairs equal exppairs_mpt.$chr\n";
			print OUT "MODEL mpt lin all equal linall_mpt.$chr\n";
#			print OUT "MODEL mpt exp all equal expall_mpt.$chr\n";
#			print OUT "MODEL mpt lin robdom equal linrobdom_equal_mpt.$chr\n";
#			print OUT "MODEL mpt lin ps:0/0/1 equal lin001_mpt.$chr\n";
#			print OUT "MODEL mpt lin ps:1/0/0 equal lin100_mpt.$chr\n";
#			print OUT "MODEL mpt exp mnallele equal expmnallele_equal_mpt.$chr\n";
#			print OUT "MODEL mpt lin mnallele equal expmnallele_equal_mpt.$chr\n";
#			print OUT "MODEL mpt exp homoz equal exphomoz_equal_mpt.$chr\n";
#			print OUT "MODEL mpt lin homoz equal linhomoz_equal_mpt.$chr\n";
# 			print OUT "ENTROPY ON\n";
 			print OUT "MAXMEMORY  1200\n";
#			print OUT "SWAPDIRNAME SWAPDIR\n";
#			print OUT "HAPLOTYPE\n";
		}
		else { 
			my @v= split('\.',$weights);
#			print OUT "MODEL mpt par het param_mpt.$chr\n";
#			print OUT "MODEL mpt exp all weights:$weights expall_$v[0].$chr\n";
#			print OUT "MODEL mpt lin all weights:$weights linall_$v[0].$chr\n";
#			print OUT "MODEL mpt exp homoz weights:$weights exphomoz_${weights}_mpt.$chr\n";			
		}
########################################################
		close (OUT);
		system ("allegro allegro.in");
#		unlink ("SWAPDIR");
		chdir  ".." ;
	}
}
