#!/usr/bin/perl

# Start script for genome wide Merlin scan, chromosome by chromosome, no moving window 
# (c) 2004 Franz Rueschendorf 

# usage: perl merlin_start.pl

use Cwd;
use strict;

my $command="";
my $prog="merlin";

# foreach my $chr ("01"){		# use this line when one or some chromosomes should be calculated

foreach my $chr ("01","02","03","04","05","06","07","08","09","10","11","12","13","14","15","16","17","18","19","20","21","22","23","24") {
	if ( -d "c$chr") {
		
		chdir "c${chr}";
		print "Calculate chromosome $chr\n";

#----------------- modify genetic model here  -------------#
		open (OUT,"> param.tbl") || die "could not open param.tbl :$!\n";
#		print OUT "TRAIT   0.05 0.00,0.00,0.90 Common_Recessive\n";
#		print OUT "TRAIT   0.001 0.00,0.990,0.990 Rare_Dominant\n";
#		print OUT "TRAIT   0.02 0.05,0.90,0.90 Common_Dominant\n";

#		if ($chr == 23) {print OUT "TRAIT   0.001 0.00,0.99,0.99 Rare_Dominant\n";}
#		else {print OUT "TRAIT   0.001 0.00,1.00,1.00 Rare_Dominant\n";}

		if ($chr == 23) {print OUT "TRAIT   0.001 0.00,0.01,0.99 Rare_Recessive\n";}
		else {print OUT "TRAIT   0.001 0.00,0.00,1.00 Rare_Recessive\n";}
		close (OUT);
#--------------------- end genetic model ------------------#

		if (-f "merlin.chr") {unlink "merlin.chr";}
		if (-f "merlin.out") {unlink "merlin.out";}
		unlink glob("wiped.*");
		
		if ($chr == 23) {$prog = "minx";} else {$prog = "merlin";}

#------------- modify merlin commands here ----------------#  

		# non-parametric, parametric and error detection
		$command = "$prog -d datain.$chr -p pedin.$chr -m merlin_map.$chr --quiet --error --npl --megabytes 1200  --model > merlin.out";

		# non-parametric, parametric and haplotyping
#		$command = "$prog -d datain.$chr -p pedin.$chr -m merlin_map.$chr --quiet --error  --best --npl --megabytes 1200  --model > merlin.out";

		# LD-Cluster
#		$command = "$prog -d datain.$chr -p pedin.$chr -m merlin_map.$chr --npl  --grid 2 --cluster snp-scan.clusters > merlin.out";

		# modeling LD
#		$command = "$prog -d datain.$chr -p pedin.$chr -m merlin_map.$chr --error  --rsq 0.8 --model > rsq0.8_merlin.out";

		system ("$command");


#		$command = "pedwipe -d datain.$chr -p pedin.$chr";
#		system ("$command");
#		$command = "$prog -d wiped.dat -p wiped.ped -m wiped.map -f wiped.freq  --quiet --best --npl --model > wiped.out";
#		system ("$command");
		
#--------------------- end edit merlin commands -----------------#

		chdir  ".." ;
	}
}
