#!/usr/bin/perl
#
# SIB_TDT_SCAN_START.PL
# Start script for genome wide ASPEX SIB_TDT runs with sets of SNPs
# This script uses Mega2 for data conversion to Mendel-Format
# ASPEX SIB-TDT was tested with up to 200 markers in a moving window on UNIX

# (c) 2004 Franz Rueschendorf 

use Cwd;
use strict;
use File::Copy;
use File::Basename;

my @files=();
my $set=0;


foreach my $chr ("01","02","03","04","05","06","07","08","09","10","11","12","13","14","15","16","17","18","19","20","21","22","23","24") {
	if ( -d "c$chr") {
		
		chdir "c${chr}";
		print "Chromosome $chr\n";
#		if (-f "SIB_TDT.out") {unlink "SIB_TDT.out";}
		$set=0;
		@files=glob("datain_*.${chr}");

		foreach (@files){
			my $basename=basename($_);
			my @feld =	split('_',$basename);
			if ($set < $feld[1]) {$set=$feld[1];}
		}

		my $command ="d2u_all";
		system ($command);		# convert all files dos2unix

		foreach my $i ( 1..$set) {
			copy ("datain_${i}.${chr}","datain.${chr}");
			copy ("pedin_${i}.${chr}","pedin.${chr}");
			copy ("map_${i}.${chr}","map.${chr}");
			open (OUT,">mega2_in.tmp") || die "could not open mega2_in.tmp :$!\n";

		# ---- Edit MEGA2 options here  ---- #

			print OUT "1\n${chr}\n0\n";
			print OUT "3\n"; 			# Aspex 
			print OUT "1\n0\n"; 		# 
			print OUT "2\n"; 			# Sib TDT
			print OUT "12\n"; 			# sex split -> true
			print OUT "14\n"; 			# mapping func kosambi
			print OUT "0\n0\n"; 		#
			
		# ---- End edit MEGA2 options ---- #

			close (OUT);
			my $command ="mega2 < mega2_in.tmp";
			system ($command);			
			
			$command="sib_tdt -f asp_in.${chr} asp_dat.${chr} > sib_tdt_${i}.out";
			system ($command);
			$command="sib_tdt -v -f asp_in.${chr} asp_dat.${chr} > sib_tdt_v_${i}.out";
			system ($command);
		}
		unlink "datain.${chr}";
		unlink "pedin.${chr}";
		unlink "map.${chr}";
		unlink "mega2_in.tmp";
		chdir  ".." ;
	}
	else {
		print "no chromosome $chr\n";
	}
}

#################################### E N D  ##################################